const mkdirp = require('mkdirp');
const logger = require('foldik-logger').getLogger('project-x');
const {template} = require('template-x');

exports.project = function(projectTemplate) {

    function initFolders() {
        projectTemplate.paths.forEach((path) => mkdirp.sync(path()));
    }

    function initFiles() {
        projectTemplate.files.forEach((f) => { template(f.template()).put(f.params).to(f.path()) });
    }

    function logSettings() {
        logger.logJSON(projectTemplate.settings());
    }

    return {
        build: function () {
            initFolders();
            initFiles();
            logSettings();
        }
    }

}
